﻿<%@ Page language="c#" AutoEventWireup="false" codePage="1200" %>
<%@ Register TagPrefix="eb" Namespace="Soneta.Core.Web" Assembly="Soneta.Core.Web" %>
<%@ Register TagPrefix="ea" Namespace="Soneta.Web" Assembly="Soneta.Web" %>
<%@ import Namespace="Soneta.Types" %>
<%@ import Namespace="System.Collections.Generic" %>
<%@ import Namespace="Soneta.Kadry" %>
<%@ import Namespace="Soneta.Kalend" %>
<%@ import Namespace="Soneta.Zadania" %>
<%@ import Namespace="Soneta.Business" %>
<%@ import Namespace="Enova.Place.KosztyProjektow" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<HTML>
	<HEAD>
		<TITLE>lista płac - podział kosztów</TITLE>
		<script runat="server">
		    
            string domyślnySymbol;
            string nazwaCechy;
            Dictionary<MyTuple<Pracownik, IComparable>, Time> czasNaProjektach = new Dictionary<MyTuple<Pracownik, IComparable>, Time>();

            void OnContextLoad(Object sender, EventArgs args) {
                Row[] rows = (Row[])dc[typeof(Row[])];
                Config config = Config.Create(dc);
                domyślnySymbol = config.DomyślnySymbol;
                nazwaCechy = config.NazwaCechy;

                FromTo okres = ((OkresContext)dc[typeof(OkresContext)]).Okres;
                if (okres == new YearMonth(okres.To))
                    ReportHeader1["OKRES"] = new YearMonth(okres.To).ToString();
                else
                    ReportHeader1["OKRES"] = okres.ToString();
                    
                foreach (PracownikIdx idx in rows) {
                    List<IStrefa> strefy = new List<IStrefa>();
                    foreach (IDzien dzień in idx.Pracownik.DniPracy[okres])
                        foreach (IStrefa strefa in dzień.Strefy)
                            strefy.Add(strefa);

                    foreach (ZestawieniePracy zestawienie in idx.Pracownik.Zestawienia[okres])
                        foreach (IStrefa strefa in zestawienie.Strefy)
                            strefy.Add(strefa);

                    foreach (IStrefa strefa in strefy)
                        if (strefa.Definicja.Features.GetBool("Podział kosztów")) {
                            IComparable projekt = (IComparable)((IRow)strefa).Features[nazwaCechy];
                            Time czas; ;
                            MyTuple<Pracownik, IComparable> key = new MyTuple<Pracownik, IComparable>(idx.Pracownik, projekt);
                            if (!czasNaProjektach.TryGetValue(key, out czas))
                                czasNaProjektach.Add(key, strefa.Czas);
                            else
                                czasNaProjektach[key] = czas + strefa.Czas;
                        }
                }

                List<MyTuple<Pracownik, IComparable>> keys = new List<MyTuple<Pracownik, IComparable>>(czasNaProjektach.Keys);
                keys.Sort();
                Grid.DataSource = keys;
            }

            protected void Grid_BeforeRow(object sender, RowEventArgs args) {
                MyTuple<Pracownik, IComparable> key = (MyTuple<Pracownik, IComparable>)args.Row;
                colProjekt.EditValue = key.Value2 != null && key.Value2.ToString() != "" ? key.Value2.ToString() : domyślnySymbol;
                colCzas.EditValue = czasNaProjektach[key];
            }

</script>
		<META content="C#" name="CODE_LANGUAGE">
		<META content="JavaScript" name="vs_defaultClientScript">
		<META content="http://schemas.microsoft.com/intellisense/ie5" name="vs_targetSchema">
	</HEAD>
	<BODY>
		<FORM method="post" runat="server">
			<ea:DataContext id="dc" runat="server" oncontextload="OnContextLoad"></ea:DataContext>
			<eb:reportheader id="ReportHeader1" title="Czas pracy wg projektów - szczegółowy|&lt;/strong&gt;Okres: &lt;strong&gt;%OKRES%"
				runat="server"></eb:reportheader>
			<ea:Grid id="Grid" runat="server" 
                RowTypeName="Soneta.Kalend.DzienPracy,Soneta.KadryPlace" 
                onbeforerow="Grid_BeforeRow" GroupData0="Value1" GroupLine="{0}" 
                ShowGroupSum="True">
				<Columns>
					<ea:GridColumn Width="4" Align="Right" DataMember="#" Caption="LP."></ea:GridColumn>
					<ea:GridColumn runat="server" ID="colProjekt" Caption="Projekt" Total="Info" 
                        EncodeHTML="True"></ea:GridColumn>
				    <ea:GridColumn runat="server" Align="Right" ID="colCzas" 
                        Caption="Czas przepracowany" Total="Sum"></ea:GridColumn>
				</Columns>
			</ea:Grid>
			<eb:ReportFooter id="ReportFooter1" runat="server">
			</eb:ReportFooter>
		</FORM>
	</BODY>
</HTML>
